A. Increasing by Modulo(思维+二分+贪心)

104 篇文章 0 订阅
62 篇文章 2 订阅

https://codeforces.com/problemset/problem/1168/A


思路:

每次都尽量让最后面的数最小.现在假设次数是x

  1. 如果a[i]<a[i−1],那么我们必须使用至少a[i−1]−a[i]次来使得非降.并且我们一定希望a[i]最小,所以如果可以的话就直接把它变成a[i−1]

  2. 如果a[i]>a[i−1],那么如果能把它变成a[i−1]是最好的,这样需要的次数是a[i−1]+ma[i].如果变不成就保持原样.

  3. 如果a[i]=a[i−1],那么什么都不需要干.

所以这个假设就是二分答案

#include<iostream>
#include<vector>
#include<queue>
#include<cstring>
#include<cmath>
#include<map>
#include<set>
#include<cstdio>
#include<algorithm>
#define debug(a) cout<<#a<<"="<<a<<endl;
using namespace std;
const int maxn=3e5+100;
typedef long long LL;
inline LL read(){LL x=0,f=1;char ch=getchar();	while (!isdigit(ch)){if (ch=='-') f=-1;ch=getchar();}while (isdigit(ch)){x=x*10+ch-48;ch=getchar();}
return x*f;}
LL a[maxn],b[maxn];
bool check(LL x,LL n,LL m){
    for(LL i=1;i<=n;i++) b[i]=a[i];
    for(LL i=1;i<=n;i++){
        if(b[i-1]>b[i]){
            if(b[i-1]-b[i]>x) return false;
            else b[i]=b[i-1];
        }
        else if(b[i]>b[i-1]){
            if(b[i-1]+m-b[i]<=x) b[i]=b[i-1];
        }
    }
    return true;
}
int main(void)
{
  cin.tie(0);std::ios::sync_with_stdio(false);
  LL n,m;cin>>n>>m;
  for(LL i=1;i<=n;i++){
    cin>>a[i];
  }
  LL l=0;LL r=1e17;
  while(l<r){
    LL mid=(l+r)>>1;
    if(check(mid,n,m)) r=mid;
    else l=mid+1;
  }
  cout<<l<<"\n";
return 0;
}

 

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值